%global momorel 7

%global desktop_file_utils_version 0.9
%global nspr_version 4.6
%global nss_version 3.11.1
%global cairo_version 0.5
%global mozillalibdir %{_libdir}/%{name}

Summary: A wysiwyg HTML editor
Name: kompozer
Version: 0.7.10
Release: %{momorel}m%{?dist}
URL: http://www.kompozer.net/
License: MPLv1.1 or GPLv2+ or LGPLv2+
Group: Applications/Editors
Source0: http://dl.sourceforge.net/sourceforge/%{name}/%{name}-%{version}dfsg-src.tar.gz
NoSource: 0
Source1: nvu-rebuild-databases.pl.in
Source2: nvu-generate-chrome.sh
Source3: kompozer-mozconfig
Source4: kompozer.desktop
Patch0: nvu-freetype2.patch
Patch1: nvu-myspell.patch
Patch4: nvu-locale.patch
Patch5: nvu-0.81-systemnspr.patch
# (fc) 0.81-3mdk fix extension manager (from Firefox package)
Patch7: nvu-0.81-fixextensionmanager.patch
# (fc) 0.81-4mdk fix GIF vulnerability CAN-2005-0399
Patch8: nvu-0.81-gifvulnerability.patch
# (fc) 1.0.2-2mdk fix JS vulnerability (CVS) (Moz bug #288688)
Patch9: nvu-0.81-jsvulnerability.patch
# (fc) 1.0.2-2mdk add env variable to disable GNOME uri handler (Fedora)
Patch10: nvu-0.81-gnome-uriloader.patch
Patch13: kompozer-0.7.10-vendor.patch
# (fc) 1.0-3mdk fix default app for www/ftp
Patch14: kompozer-0.7.10-browser.patch
# (couriousous) fix gcc 4.1 build
Patch16: nvu-gcc4.1-fix.patch
# Fix underlinking - AdamW 2008/09
Patch17: kompozer-0.7.10-underlinking.patch
# Fix an overflow (which causes app to fail to run when built with
# fortification, #44830) - thanks Willem van Engen - AdamW 2008/12
Patch18: kompozer-0.7.10-overflow.patch
Patch19: kompozer-0.7.10-wformat.patch
Patch20: kompozer-0.7.10-gcc44.patch
Patch21: kompozer-0.7.10-CVE-2009-XXXX.diff

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  nspr-devel >= %{nspr_version}
BuildRequires:  nss-devel >= %{nss_version}
BuildRequires:  cairo-devel >= %{cairo_version}
BuildRequires:  pango-devel
BuildRequires:  gtk+-devel >= 2.8.3-2m
BuildRequires:  libpng-devel
BuildRequires:  libjpeg-devel
BuildRequires:  zlib-devel, zip
BuildRequires:  libIDL-devel
BuildRequires:  desktop-file-utils
BuildRequires:  gnome-vfs-devel
BuildRequires:  libgnome-devel
BuildRequires:  libgnomeui-devel
BuildRequires:  krb5-devel
BuildRequires:  freetype-devel >= 2.1.9
BuildRequires:  libXt-devel
BuildRequires:  libXrender-devel

Requires: nspr >= %{nspr_version}
Requires: nss >= %{nss_version}
Requires: desktop-file-utils >= %{desktop_file_utils_version}

%description
KompoZer is a complete web authoring system that combines web file management
and easy-to-use WYSIWYG web page editing.

%package devel
Summary: Kompozer development files
Group: Applications/Editors
Requires: %{name} = %{version}

%description devel
Kompozer development files.

%prep
%setup -q -n %{name}-%{version}
%setup -T -D -n %{name}-%{version}/mozilla
%patch0 -p1
%patch1 -p1
%patch4
%patch5 -p1 -b .systemnspr
%patch7 -p1 -b .fixextensionmanager
%patch8 -p1 -b .gifvulnerability
%patch9 -p1 -b .jsvulnerability
%patch10 -p1 -b .gnome-uriloader
%patch13 -p1 -b .vender
%patch14 -p1 -b .launcher
%patch16 -p0 -b .gcc4.1
%patch17 -p1 -b .underlink
%patch18 -p1 -b .overflow
%patch19 -p1 -b .wformat
%patch20 -p1 -b .gcc44
%patch21 -p0 -b .CVE-2009-XXXX

# let jars get compressed
%__perl -p -i -e 's|\-0|\-9|g' config/make-jars.pl

%{__rm} -f .mozconfig
%{__cp} %{SOURCE3} .mozconfig

%build
# required by underlinking.patch
autoconf-2.13

MOZ_OPT_FLAGS=$(echo $RPM_OPT_FLAGS | %{__sed} -e 's/-O2/-Os/' -e 's/-Wall//')
export RPM_OPT_FLAGS=$MOZ_OPT_FLAGS
export PREFIX='%{_prefix}'
export LIBDIR='%{_libdir}'

%ifarch ppc ppc64 s390 s390x
%define moz_make_flags -j1
%else
%define moz_make_flags %{?_smp_mflags}
%endif

export LDFLAGS="-Wl,-rpath,%{mozillalibdir}"
export MAKE="gmake %{moz_make_flags}"
%{__make} -f client.mk build


%install
%{__rm} -rf %{buildroot}
DESTDIR=%{buildroot} %{__make} install

# Desktop File
mkdir -p %{buildroot}%{_datadir}/applications
%{__cp} %{SOURCE4} %{buildroot}%{_datadir}/applications/

# Icon
mkdir -p %{buildroot}%{_datadir}/pixmaps/
convert -scale 48x48  %{buildroot}%{mozillalibdir}/icons/mozicon50.xpm \
 %{buildroot}%{_datadir}/pixmaps/%{name}.png 

# mozilla-rebuild-databases.pl & generate-chrome.sh
sed -e "s|mozilla-MOZILLA_VERSION|%{name}-%{version}|g;s|LIBDIR|%{_libdir}|g" \
 %{SOURCE1} > %{buildroot}%{mozillalibdir}/mozilla-rebuild-databases.pl
chmod 755 %{buildroot}%{mozillalibdir}/mozilla-rebuild-databases.pl

mkdir -p %{buildroot}%{mozillalibdir}/chrome/rc.d
%{__cp} %{SOURCE2} %{buildroot}%{mozillalibdir}/chrome/rc.d/generate-chrome.sh
chmod 755 %{buildroot}%{mozillalibdir}/chrome/rc.d/generate-chrome.sh

# remove unpackaged files
rm -f %{buildroot}%{mozillalibdir}/{libnspr4.so,libplc4.so,libplds4.so,libnss3.so,libnssckbi.so,libsmime3.so,libsoftokn3.so,libssl3.so,libsoftokn3.chk,TestGtkEmbed}

#ghost files
mkdir -p %{buildroot}%{mozillalibdir}/extensions
touch %{buildroot}%{mozillalibdir}/chrome/chrome.rdf
for overlay in {"browser","communicator","editor","inspector","messenger","navigator"}; do
  %{__mkdir_p} %{buildroot}%{mozillalibdir}/chrome/overlayinfo/$overlay/content
  touch %{buildroot}%{mozillalibdir}/chrome/overlayinfo/$overlay/content/overlays.rdf
done
touch %{buildroot}%{mozillalibdir}/extensions/installed-extensions-processed.txt
touch %{buildroot}%{mozillalibdir}/extensions/Extensions.rdf
touch %{buildroot}%{mozillalibdir}/components.ini
touch %{buildroot}%{mozillalibdir}/defaults.ini
touch %{buildroot}%{mozillalibdir}/components/compreg.dat
touch %{buildroot}%{mozillalibdir}/components/xpti.dat


%clean
%{__rm} -rf %{buildroot}

%post
if [ "$1" == "2" ]; then
  if [ ! -f %{mozillalibdir}/components.ini -o ! -f %{mozillalibdir}/defaults.ini ]; then
	#fix older broken install if needed
	rm -f %{mozillalibdir}/components/*.dat
  fi
fi

export HOME="/root" MOZ_DISABLE_GNOME=1
# force correct umask
umask 022
%{_bindir}/%{name} -register
/sbin/ldconfig >/dev/null 2>/dev/null
if [ "$1" == "2" ]; then
  if [ -f %{mozillalibdir}/mozilla-rebuild-databases.pl ]; then
    %{mozillalibdir}/mozilla-rebuild-databases.pl
  fi
fi

%postun
/sbin/ldconfig >/dev/null 2>/dev/null
if [ "$1" == "2" ]; then
  if [ -f %{mozillalibdir}/mozilla-rebuild-databases.pl ]; then
    %{mozillalibdir}/mozilla-rebuild-databases.pl
  fi
fi


%files
%defattr(-,root,root)
%doc LICENSE LEGAL README.txt
%{_bindir}/kompozer
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/kompozer.png 
%dir %{mozillalibdir}
%dir %{mozillalibdir}/chrome
%{mozillalibdir}/chrome/cascades.jar
%{mozillalibdir}/chrome/chromelist.txt
%{mozillalibdir}/chrome/classic.jar
%{mozillalibdir}/chrome/comm.jar
%{mozillalibdir}/chrome/embed-sample.jar
%{mozillalibdir}/chrome/en-US.jar
%{mozillalibdir}/chrome/help.jar
%{mozillalibdir}/chrome/icons/default/default.xpm
%{mozillalibdir}/chrome/installed-chrome.txt
%{mozillalibdir}/chrome/pipnss.jar
%{mozillalibdir}/chrome/pippki.jar
%{mozillalibdir}/chrome/rc.d/generate-chrome.sh
%{mozillalibdir}/chrome/tipoftheday.jar
%{mozillalibdir}/chrome/toolkit.jar
%{mozillalibdir}/chrome/overlayinfo/editor/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/chrome.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/browser/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/communicator/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/inspector/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/messenger/content/overlays.rdf
%ghost %{mozillalibdir}/chrome/overlayinfo/navigator/content/overlays.rdf

%dir %{mozillalibdir}/extensions
%ghost %{mozillalibdir}/extensions/Extensions.rdf
%ghost %{mozillalibdir}/extensions/installed-extensions-processed.txt

%dir %{mozillalibdir}/components
%ghost %{mozillalibdir}/components/compreg.dat
%ghost %{mozillalibdir}/components/xpti.dat
%{mozillalibdir}/components/*.xpt
%{mozillalibdir}/components/*.js
%{mozillalibdir}/components/*.so
%{mozillalibdir}/components/myspell/en-US.aff
%{mozillalibdir}/components/myspell/en-US.dic

%dir %{mozillalibdir}/plugins
%{mozillalibdir}/plugins/libnullplugin.so

%{mozillalibdir}/defaults
%{mozillalibdir}/greprefs
%{mozillalibdir}/icons
%{mozillalibdir}/res

%ghost %{mozillalibdir}/components.ini
%ghost %{mozillalibdir}/defaults.ini
%{mozillalibdir}/kompozer-bin
%{mozillalibdir}/*.so
%{mozillalibdir}/mozilla-rebuild-databases.pl
%{mozillalibdir}/mozilla-xremote-client
%{mozillalibdir}/regchrome
%{mozillalibdir}/regxpcom
%{mozillalibdir}/run-mozilla.sh
%{mozillalibdir}/xpcshell
%{mozillalibdir}/xpicleanup
%{mozillalibdir}/xpidl
%{mozillalibdir}/xpt_dump
%{mozillalibdir}/xpt_link

%files devel
%defattr(-,root,root)
%{_libdir}/pkgconfig/*.pc
%{_bindir}/kompozer-config
%{_datadir}/idl/kompozer
%{_includedir}/kompozer

%changelog
* Fri Sep 18 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.7.10-7m)
- [SECURITY] CVE-2009-2625
- [SECURITY] Expat UTF-8 Parser DoS (Patch21)
- import Patch17-21 from Mandriva Cooker (0.7.10-6mdv2010.0)
- License: MPLv1.1 or GPLv2+ or LGPLv2+
-- my mistake

* Sat Feb 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.7.10-5m)
- apply gcc44 patch

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.7.10-4m)
- rebuild against rpm-4.6

* Tue Jan 13 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.7.10-3m)
- update Patch13 for fuzz=0
- License: MPLv1.1 and GPLv2+ and LGPLv2+

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.7.10-2m)
- rebuild against gcc43

* Thu Oct  4 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.7.10-1m)
- initial import (based on cooker 0.7.10-1mdv2008.0)

